Index: trunk/kernel/kern/dqdt.c
===================================================================
--- trunk/kernel/kern/dqdt.c	(revision 690)
+++ trunk/kernel/kern/dqdt.c	(revision 1)
@@ -598,75 +263,47 @@
     // analyse load for all children in non terminal node
     load_min = 0xFFFFFFFF;
-    select_x = 0;
-    select_y = 0;
-    for( x = 0 ; x < 2 ; x++ )
-    {
-        for( y = 0 ; y < 2 ; y++ )
+    for( i = 0 ; i < 4 ; i++ )
+    {
+        child = node_copy.children[i];
+        if( child != XPTR_NULL )
         {
-            child_xp = node_copy.children[x][y];
-            if( child_xp != XPTR_NULL )
-            {
-                cxy_t         cxy  = GET_CXY( child_xp );
-                dqdt_node_t * ptr  = GET_PTR( child_xp );
-
-                // compute average load  for each child
-                if( for_memory )
-                {
-                    load = hal_remote_l32( XPTR( cxy , &ptr->pages ) ) /
-                           hal_remote_l32( XPTR( cxy , &ptr->clusters ) );
-                }
-                else
-                {
-                    load = hal_remote_l32( XPTR( cxy , &ptr->threads ) ) /
-                           hal_remote_l32( XPTR( cxy , &ptr->cores ) );
-                }
-
-                // select children with smallest load
-                if( load <= load_min )
-                {
-                    load_min = load;
-                    select_x = x;
-                    select_y = y;
-                }
-            }
+            cxy  = (cxy_t)GET_CXY( child );
+            ptr  = (dqdt_node_t *)GET_PTR( child ); 
+            if( for_memory ) load = hal_remote_lw( XPTR( cxy , &ptr->pages ) );
+            else             load = hal_remote_lw( XPTR( cxy , &ptr->threads ) );
+            if( load < load_min )
+            {
+                load_min = load;
+                select   = i; 
+            }      
         }
     }
 
     // select the child with the lowest load
-    return dqdt_select_cluster( node_copy.children[select_x][select_y], for_memory );
-
-}  // end dqdt_select_cluster()
-
-
-///////////////////////////////////////////////////
-cxy_t dqdt_get_cluster_for_thread( xptr_t root_xp )
-{
+    return dqdt_select_cluster( node_copy.children[select], for_memory ); 
+}
+
+////////////////////////////////////
+cxy_t dqdt_get_cluster_for_process()
+{
+    // build extended pointer on DQDT root node
+	cluster_t * cluster = LOCAL_CLUSTER;
+    uint32_t    level   = cluster->dqdt_root_level;
+    xptr_t      root    = XPTR( 0 , &cluster->dqdt_tbl[level] );
+
     // call recursive function
-    cxy_t cxy = dqdt_select_cluster( root_xp , false );
-
-#if DEBUG_DQDT_SELECT_FOR_THREAD
-uint32_t cycle = hal_get_cycles();
-if( cycle > DEBUG_DQDT_SELECT_FOR_PROCESS )
-printk("\n[DBG] %s : thread %x in process %x select cluster %x / cycle %d\n",
-__FUNCTION__, CURRENT_THREAD->trdid, CURRENT_THREAD->process->pid, cxy, cycle );
-#endif
-
-    return cxy;
-}
-
-///////////////////////////////////////////////////
-cxy_t dqdt_get_cluster_for_memory( xptr_t root_xp )
-{
+    return dqdt_select_cluster( root , false ); 
+}
+
+////////////////////////////////////
+cxy_t dqdt_get_cluster_for_memory()
+{
+    // build extended pointer on DQDT root node
+	cluster_t * cluster = LOCAL_CLUSTER;
+    uint32_t    level   = cluster->dqdt_root_level;
+    xptr_t      root    = XPTR( 0 , &cluster->dqdt_tbl[level] );
+
     // call recursive function
-    cxy_t cxy = dqdt_select_cluster( root_xp , true );
-
-#if DEBUG_DQDT_SELECT_FOR_MEMORY
-uint32_t cycle = hal_get_cycles();
-if( cycle > DEBUG_DQDT_SELECT_FOR_MEMORY )
-printk("\n[DBG] %s : thread %x in process %x select cluster %x / cycle %d\n",
-__FUNCTION__, CURRENT_THREAD->trdid, CURRENT_THREAD->process->pid, cxy, cycle );
-#endif
-
-    return cxy;
-}
-
+    return dqdt_select_cluster( root , true ); 
+}
+
Index: trunk/kernel/kern/dqdt.h
===================================================================
--- trunk/kernel/kern/dqdt.h	(revision 690)
+++ trunk/kernel/kern/dqdt.h	(revision 1)
@@ -1,6 +1,6 @@
 /*
  * kern/dqdt.h - Distributed Quad Decision Tree
- *
- * Author : Alain Greiner (2016,2017,2018,2019)
+ * 
+ * Author : Alain Greiner (2016)
  *
  * Copyright (c)  UPMC Sorbonne Universites
@@ -25,29 +25,34 @@
 #define _DQDT_H_
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
+#include <almos_config.h>
+#include <hal_types.h>
 #include <hal_atomic.h>
 
 /****************************************************************************************
  * This DQDT infrastructure maintains a topological description of ressources usage
- * in each cluster: number of threads per core, and number of physical pages allocated.
+ * (number of threads, and number of physical pages allocated) in each cluster.
  *
- * It is organized as a quad-tree, where the leaf cells are the clusters, organised
- * as a 2D mesh. Each node in the quad-tree (including the root and the leaf cells,
- * covers a "macro-cluster", that is a square array of clusters where the number
- * in the macro-cluster is a power of 4, and the macro-cluster side is a power of two.
- * Each node contains informations on ressources usage (physical memory and cores)
- * in the covered macro-cluster.
- * This quad-tree can be truncated, if the physical mesh X_SIZE and Y_SIZE dimensions
- * are not equal, or are not power of 2, or if the physical mesh contains "holes".
- * The mesh size is supposed to contain at most 32*32 clusters in this implementation.
- *   . Level 0 nodes exist in all clusters and have no children.
- *   . Level 1 nodes can be placed in any cluster of the covered  2*2  macro-cluster.
- *   . Level 2 nodes can be placed in any cluster of the covered  4*4  macro-cluster.
- *   . Level 3 nodes can be placed in any cluster of the covered  8*8  macro-cluster.
- *   . Level 4 nodes can be placed in any cluster of the covered 16*16 macro-cluster.
- *   . Level 5 nodes can be placed in any cluster of the covered 32*32 macro-cluster.
- * The root node is placed in the cluster containing the core executing the dqdt_init()
- * function. Other (non level 0) nodes are placed pseudo-randomly.
+ * - If X_SIZE or Y_SIZE are equal to 1, it makes the assumption that the cluster
+ *   topology is a one dimensionnal vector, an build the smallest one-dimensionnal
+ *   quad-tree covering this one-dimensionnal vector. If the number of clusters 
+ *   is not a power of 4, the tree is truncated as required.
+ *   TODO : the mapping for the one dimensionnal topology is not implemented yet [AG].
+ * 
+ * - If both Y_SIZE and Y_SIZE are larger than 1, it makes the assumption that 
+ *   the cluster topology is a 2D mesh. The [X,Y] coordinates of a cluster are 
+ *   obtained from the CXY identifier using the following rules :  
+ *      X = CXY >> Y_WIDTH   /  Y = CXY & ((1<<Y_WIDTH)-1)
+ *   If the mesh X_SIZE and Y_SIZE dimensions are not equal, or are not power of 2, 
+ *   we build the smallest two dimensionnal quad-tree covering all clusters,
+ *   and this tree is truncated as required.
+ *   The root node is always implemented in cluster [0,0]
+ *   The mesh size is supposed to contain at most 32 * 32 clusters.
+ *   There are at most 6 DQDT nodes in a cluster 
+ *   . Level 0 nodes exist on all clusters and have no children.
+ *   . Level 1 nodes exist when both X and Y coordinates are multiple of 2 
+ *   . Level 2 nodes exist when both X and Y coordinates are multiple of 4
+ *   . Level 3 nodes exist when both X and Y coordinates are multiple of 8
+ *   . Level 4 nodes exist when both X and Y coordinates are multiple of 16
+ *   . Level 5 nodes exist when both X and Y coordinates are multiple of 32
  ***************************************************************************************/
 
@@ -55,17 +60,15 @@
  * This structure describes a node of the DQDT.
  * The max number of children is 4, but it can be smaller for some nodes.
- * Level 0 nodes have no children. The root node has no parent.
+ * Level 0 nodes are the clusters, and have no children.
+ * The root node has no parent, and is always stored in cluster[0,0].
  ***************************************************************************************/
-
 typedef struct dqdt_node_s
 {
-	uint32_t      level;            /*! node level                                     */
-	uint32_t      arity;            /*! actual children number in this node            */
-    uint32_t      threads;          /*! number of threads in macro-cluster             */
-    uint32_t      pages;            /*! number of allocated pages in macro-cluster     */
-    uint32_t      cores;            /*! number of active cores in macro cluster        */
-    uint32_t      clusters;         /*! number of active clusters in macro cluster     */ 
-	xptr_t        parent;           /*! extended pointer on parent node                */
-	xptr_t        children[2][2];   /*! extended pointers on children nodes            */
+	uint32_t            level;               // node level
+	uint32_t            arity;               // actual children number in this node
+    uint32_t            threads;             // current number of threads in subtree
+    uint32_t            pages;               // current number of pages in subtree
+	xptr_t              parent;              // extended pointer on parent node
+	xptr_t              children[4];         // extended pointers on children nodes
 }
 dqdt_node_t;
@@ -73,81 +76,80 @@
 
 /****************************************************************************************
- * This function recursively initializes the DQDT structure from informations
- * stored in cluster manager (x_size, y_size and cluster_info[x][y].
- * It is called in all clusters by the local CP0, to compute level_max and register
- * the DQDT root node in each cluster manager, but only CPO in cluster 0 build actually
- * the quad-tree covering all active clusters.
- * This initialisation can use remote_accesses, because the DQDT nodes are
- * allocated as global variables in the cluster_manager, and the local addresses
+ * This local function initializes the local DQDT structures. 
+ * The information describing the hardware platform topology and the cluster
+ * indexing policy is defined by the three arguments below.
+ * This initialisation is done in parallel, locally in each cluster, because the DQDT 
+ * is allocated as a global variable in the cluster_manager, and the local addresses
  * are identical in all clusters.
+ ****************************************************************************************
+ * @ x_size   : number of clusters (containing memory and CPUs) in a row
+ * @ y_size   : number of clusters (containing memory and CPUs) in a column
+ * @ y_width  : number of LSB used to code the Y value in CXY
+ * @ return the number of levels in quad-tree.
  ***************************************************************************************/
-void dqdt_init( void );
+uint32_t dqdt_init( uint32_t x_size,
+                    uint32_t y_size,
+                    uint32_t y_width );
 
 /****************************************************************************************
- * These local function update the total number of threads in level 0 DQDT node,
- * and immediately propagates the variation to the DQDT upper levels.
- * They are called on each thread creation or destruction.
+ * This recursive function displays usage information for all DQDT nodes in the subtree
+ * defined by the node argument. It traverses the quadtree from root to bottom.
+ ****************************************************************************************
+ * @ node_xp   : extended pointer on a DQDT node.
  ***************************************************************************************/
-void dqdt_increment_threads( void );
-
-void dqdt_decrement_threads( void );
+void dqdt_global_print( xptr_t  node_xp );
 
 /****************************************************************************************
- * These two functions can be called by any thread running in any cluster.
- * They increment/decrement the total number of 4 Kbytes pages allocated in a cluster
- * identified by the <cxy> argument, as specified by the <order> argument. The level 0 
- * DQDT node is udated, and this change is immediately propagated to upper levels.
- * They are called by PPM on each physical memory page allocation or release.
+ * This function displays summary usage information in a given DQDT local node.
  ****************************************************************************************
- * @ cxy     : target cluster identifier.
- * @ order   : ln2( number of 4 Kbytes pages )
+ * @ node   : local pointer on a DQDT node.
  ***************************************************************************************/
-void dqdt_increment_pages( cxy_t    cxy , 
-                           uint32_t order );
-
-void dqdt_decrement_pages( cxy_t    cxy,
-                           uint32_t order );
+void dqdt_local_print( dqdt_node_t * node );
 
 /****************************************************************************************
- * This function returns an extended pointer on the dqdt node that is the root of
- * the sub-tree covering the macro-cluster defined by the <level> argument and
- * containing the cluster defined by the <cxy> argument. It returns XPTR_NULL if
- * this macro-cluster is undefined (when the cxy cluster contains no core).
- ****************************************************************************************
- * @ cxy   : cluster identifier.
- * @ level   : level of the sub-tree.
- * @ returns  root_xp if success / return XPTR_NULL if no active core in macro_cluster.
+ * This recursive function traverses the DQDT quad-tree from bottom to root, to propagate
+ * the change in the threads number and allocated pages number in a leaf cluster,
+ * toward the upper levels of the DQDT quad-tree.
+ * It should be called periodically by each instance of the kernel.
  ***************************************************************************************/
-xptr_t dqdt_get_root( cxy_t    cxy,
-                      uint32_t level );
+void dqdt_global_update();
 
 /****************************************************************************************
- * This function can be called in any cluster. It traverses the DQDT tree from the
- * local root of a macro-cluster, defined by the <root_xp> argument, to the bottom.
- * It analyses the computing load & select the cluster containing the lowest number
- * ot threads.
+ * This local function updates both the total number of threads,
+ * in the level 0 DQDT node, and the variation of the number of threads
+ * for future propagation to the DQDT upper levels. 
+ * It should be called on each thread creation or destruction.
  ****************************************************************************************
- * @ root_xp  : extended pointer on DQDT node root.
+ * @ increment : increment (can be positive or negative)
+ ***************************************************************************************/
+void dqdt_local_update_threads( int32_t  increment );
+
+/****************************************************************************************
+ * This local function updates both the total number of allocated pages,
+ * in the level 0 DQDT node, and the variation of the number of pages
+ * for future propagation to the DQDT upper levels. 
+ * It should be called on each memory allocation or release.
+ ****************************************************************************************
+ * @ increment : increment (can be positive or negative)
+ ***************************************************************************************/
+void dqdt_local_update_pages( int32_t increment );
+
+/****************************************************************************************
+ * This function can be called in any cluster. It traverses the DQDT tree
+ * from the root to the bottom, to analyse the computing load and select the cluster
+ * with the lowest number ot threads to place a new process.
+ ****************************************************************************************
  * @ returns the cluster identifier with the lowest computing load.
  ***************************************************************************************/
-cxy_t dqdt_get_cluster_for_thread( xptr_t root_xp );
+cxy_t dqdt_get_cluster_for_process();
 
 /****************************************************************************************
- * This function can be called in any cluster. It traverses the DQDT tree from the
- * local root of a macro-cluster, defined by the <root_xp> argument, to the bottom.
- * It analyses the memory load & select the cluster with the lowest number of allocated
- * physical pages.
+ * This function can be called in any cluster. It traverses the DQDT tree
+ * from the root to the bottom, to analyse the memory load and select the cluster 
+ * with the lowest memory load for dynamic memory allocation with no locality constraint.
  ****************************************************************************************
- * @ root_xp  : extended pointer on DQDT node root.
  * @ returns the cluster identifier with the lowest memory load.
  ***************************************************************************************/
-cxy_t dqdt_get_cluster_for_memory( xptr_t root_xp );
-
-/****************************************************************************************
- * This function displays on kernel TXT0 the DQDT state for all nodes in the quad-tree.
- * It traverses the quadtree from the global root to bottom.
- * It can be called by a thread running in any cluster
- ***************************************************************************************/
-void dqdt_display( void );
+cxy_t dqdt_get_cluster_for_memory();
 
 
Index: trunk/kernel/kern/event.c
===================================================================
--- trunk/kernel/kern/event.c	(revision 1)
+++ trunk/kernel/kern/event.c	(revision 1)
@@ -0,0 +1,365 @@
+/*
+ * kern/event.c - Per-CPU Events-Manager
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <types.h>
+#include <cpu.h>
+#include <cluster.h>
+#include <device.h>
+#include <pmm.h>
+#include <event.h>
+#include <cpu-trace.h>
+#include <thread.h>
+
+/** Initialize event */
+error_t event_init(struct event_s *event)
+{
+	/* nothing to do in this version */
+	return 0;
+}
+
+/** Destroy event */
+void event_destroy(struct event_s *event)
+{
+	/* nothing to do in this version */
+}
+
+/** Destroy event listner */
+void event_listner_destroy(struct event_listner_s *el)
+{
+	/* nothing to do in this version */
+}
+
+error_t event_listner_init(struct event_listner_s *el)
+{
+	error_t err;
+	register uint_t i;
+  
+	el->flags = 0;
+	el->prio = 0;
+	err = 0;
+
+	for(i=0; i < E_PRIO_NR; i++)
+	{
+		list_root_init(&el->tbl[i].root);
+		el->tbl[i].count = 0;
+	}
+
+
+	return 0;
+}
+
+
+static void local_event_send(struct event_s *event, struct event_listner_s *el, bool_t isFIFO) 
+{
+	uint_t prio;
+	uint_t irq_state;
+
+	prio = event_get_priority(event);
+
+	cpu_disable_all_irq(&irq_state);
+
+	if(isFIFO)
+		list_add_last(&el->tbl[prio].root, &event->e_list);
+	else
+		list_add_first(&el->tbl[prio].root, &event->e_list);
+
+	el->tbl[prio].count ++;
+	el->prio = (!(el->flags & EVENT_PENDING) || (el->prio > prio)) ? prio : el->prio;
+	el->flags |= EVENT_PENDING;
+
+	cpu_restore_irq(irq_state);
+
+#if CONFIG_SHOW_LOCAL_EVENTS
+	isr_dmsg(INFO, "%s: cpu %d, prio %d, el->prio %d [%d]\n", 
+		 __FUNCTION__, 
+		 cpu_get_id(), 
+		 prio, 
+		 el->prio,
+		 cpu_time_stamp());
+#endif
+}
+
+#if 0
+static EVENT_HANDLER(re_send_backoff_handler)
+{
+	uint_t cpu_gid;
+  
+	cpu_gid = (uint_t) event_get_argument(event);
+  
+	event_restore(event);
+  
+	event_send(event, cpu_gid);
+
+	printk(INFO, "INFO: %s, cpu %d, event %x sent to cpu_gid %d [%d]\n",
+	       __FUNCTION__,
+	       cpu_get_id(),
+	       event,
+	       cpu_gid,
+	       cpu_time_stamp());
+  
+	return 0;
+}
+
+static error_t __attribute__((noinline)) re_send_backoff(struct event_s *event, 
+							 uint_t cpu_gid, 
+							 uint_t tm_stamp)
+{
+	struct cpu_s *cpu;
+	uint_t tm_now;
+	uint_t irq_state;
+
+	tm_now = cpu_time_stamp();
+	cpu    = current_cpu;
+
+	if((tm_now - tm_stamp) < cpu_get_ticks_period(cpu))
+		return EAGAIN;
+
+	event_backup(event);
+  
+	event_set_priority(event, E_CHR);
+	event_set_handler(event, re_send_backoff_handler);
+	event_set_argument(event, (void*)cpu_gid);
+
+	cpu_disable_all_irq(&irq_state);
+	local_event_send(event, &cpu->le_listner, false);
+	cpu_restore_irq(irq_state);
+
+	printk(INFO, "INFO: %s, cpu %d, event %x sent to cpu_gid %d [%d]\n",
+	       __FUNCTION__,
+	       cpu->gid,
+	       event,
+	       cpu_gid,
+	       tm_now);
+
+	return 0;
+}
+
+/** This is the only function that handle remote data **/
+static void remote_event_send(struct event_s *event, 
+				struct event_listner_s *el, 
+				uint_t cid, uint_t cpu_gid)
+{ 
+	error_t retry;
+	uint_t tm_stamp;
+	uint_t prio;
+
+	tm_stamp = cpu_time_stamp();
+	prio     = event_get_priority(event);
+
+	while((retry = event_fifo_put(&el->tbl[prio].fifo, cid, event)) != 0)
+	{
+		retry = re_send_backoff(event, cpu_gid, tm_stamp);
+    
+		if(retry == 0)
+			break;
+	}
+
+
+#if 1
+	bool_t isPending;
+	uint_t flags = remote_lw((void*)&el->flags, cid);
+	isPending = (flags & EVENT_PENDING) ? true : false;
+
+	remote_sw((void*)&el->flags, cid, flags | EVENT_PENDING);
+	cpu_wbflush();
+	pmm_cache_flush_raddr((vma_t) &el->flags, cid, PMM_DATA);
+
+	if((prio < E_FUNC) && (isPending == false))
+	{
+		(void)arch_cpu_send_ipi(cpu_gid);
+	}
+#else
+
+	if((prio < E_FUNC))
+	{
+		(void)arch_cpu_send_ipi(cpu_gid);
+	}
+#endif
+}
+#endif
+
+/* must be called with all irq disabled */
+void event_send(struct event_s *event, uint_t cpu_gid)
+{
+	uint_t cid = arch_cpu_cid(cpu_gid);
+	uint_t lid = arch_cpu_lid(cpu_gid);
+
+	if (cid != current_cid)
+	{
+		PANIC("event not local cid [cpu %d, cid %d, cycle %u]\n", 
+		      cpu_get_id(), 
+		      cid,
+		      cpu_time_stamp());
+	}
+	
+	local_event_send(event, &cpu_lid2ptr(lid)->le_listner, true);
+}
+
+
+static void local_event_listner_notify(struct event_listner_s *el)
+{
+	register struct event_s *event;
+	register uint_t count;
+	register uint_t start_prio;
+	register uint_t current_prio;
+
+#if CONFIG_SHOW_LOCAL_EVENTS
+	register uint_t cntr;
+#endif
+  
+	count = 0;
+	assert((el->flags & EVENT_PENDING) && "event_notify is called but no event is pending");
+
+	el->flags   &= ~EVENT_PENDING;
+	start_prio   = el->prio ++;
+	current_prio = start_prio;
+
+	while(current_prio < E_PRIO_NR)
+	{
+		if(el->prio <= start_prio)
+		{
+			start_prio   = el->prio ++;
+			current_prio = start_prio;
+		}
+
+		while(el->tbl[current_prio].count != 0)
+		{
+			assert(!(list_empty(&el->tbl[current_prio].root)) && "pending event queue is empty");
+
+			event = list_first(&el->tbl[current_prio].root, struct event_s, e_list);
+			//printk(INFO, "%d Handling event %p with prio %d\n", current_cpu->gid, event, current_prio);
+			list_unlink(&event->e_list);
+      
+			el->tbl[current_prio].count --;
+      
+			cpu_enable_all_irq(NULL);
+			event_get_handler(event)(event);	 /* el->prio can be changed */
+			count ++;
+
+#if CONFIG_SHOW_LOCAL_EVENTS
+			cntr ++;
+#endif
+
+			cpu_disable_all_irq(NULL);
+		}
+
+#if CONFIG_SHOW_LOCAL_EVENTS    
+		cpu_enable_all_irq(NULL);
+		if(cntr)
+		{
+			printk(INFO, "INFO: cpu %d, %d pending events of priority %d have been Delivered [ %u ]\n",
+			       cpu_get_id(),
+			       cntr, 
+			       current_prio, 
+			       cpu_time_stamp());
+		}
+		cntr = 0;
+		cpu_disable_all_irq(NULL);
+#endif
+    
+		current_prio ++;
+	}
+
+	el->count += count;
+}
+
+
+#if 0
+static void remote_event_listner_notify(struct event_listner_s *el)
+{
+	struct event_listner_s *local_el;
+	struct event_s *event;
+	event_prio_t current_prio;
+	uint_t irq_state;
+	uint_t count;
+	error_t err;
+	uint_t cid;
+  
+	local_el = &current_cpu->le_listner;
+	cid = current_cid;
+	count    = 0;
+
+	do
+	{
+		el->flags &= ~EVENT_PENDING;
+		cpu_wbflush();
+		pmm_cache_flush_vaddr((vma_t)&el->flags, PMM_DATA);
+
+		cpu_disable_all_irq(&irq_state);
+
+		for(current_prio = E_CLK; current_prio < E_PRIO_NR; current_prio++, count++)
+		{
+			while((err = event_fifo_get(&el->tbl[current_prio].fifo, cid, (void**)&event)) == 0)
+				local_event_send(event, local_el, false);//event is local
+		}
+
+		cpu_restore_irq(irq_state);
+		el->count += count;
+
+	}while(el->flags & EVENT_PENDING);
+}
+#endif
+
+/* must be called with all irq disabled */
+void event_listner_notify(struct event_listner_s *el)
+{
+	local_event_listner_notify(el);
+}
+
+
+void* thread_event_manager(void *arg)
+{
+	struct thread_s *this;
+	struct cpu_s *cpu;
+	uint_t irq_state;
+
+	cpu_enable_all_irq(NULL);
+  
+	this = current_thread;
+	cpu  = current_cpu;
+
+	thread_preempt_disable(this);
+
+	while(1)
+	{
+#if 0
+		printk(INFO, "INFO: Event Handler on CPU %d, event is le pending %d [%d,%d]\n",
+		       cpu->gid,
+		       event_is_pending(&cpu->le_listner),
+		       cpu_time_stamp(),
+		       cpu_get_ticks(cpu)); 
+#endif
+   
+		cpu_disable_all_irq(&irq_state);
+
+		if(event_is_pending(&cpu->le_listner))
+			event_listner_notify(&cpu->le_listner);
+    
+		wait_on(&this->info.wait_queue, WAIT_ANY);
+
+		sched_sleep(this);
+
+		cpu_restore_irq(irq_state);
+	}
+
+	return NULL;
+}
